
# LibreGates/tests/test6_bigLFSR/test.sh
# created ven. nov. 20 17:26:52 CET 2020 by whygee@f-cpu.org

function iterate() {
  for i in \
     10    20    40    70    \
     100   200   400   700   \
     1000  2000  4000  7000  \
     10000 20000 #40000 70000
  do
    /usr/bin/time -f "$(( i*29 )) %M %E" $1 -glayers=$i || return
  done
}

function run_test() {
  rm -f mlfsr *.cf *.o
  ghdl -a $PA3 LFSR32x.decl.vhdl LFSR32x.vhdl &&
  ghdl -e $PA3 LFSR32x  &&
  iterate ./lfsr32x
}

[ -f ../../LibreGates/proasic3/simple/proasic3-obj93.cf ] &&

echo "Simple gate version setup (RAM+time) :" &&
PA3="-P$PWD/../../LibreGates -P$PWD/../../LibreGates/proasic3/simple" &&
run_test &&

echo "Detailed gate version setup (RAM+time) :" &&
PA3="-P$PWD/../../LibreGates -P$PWD/../../LibreGates/proasic3" &&
run_test &&

../../LibreGates/wrap_netlist.sh $PA3 LFSR32x.decl.vhdl > LFSR32x_Wrapped.vhdl &&
rm -f lfsr32x *.cf *.o
ghdl -a $PA3 LFSR32x.decl.vhdl LFSR32x.vhdl LFSR32x_Wrapped.vhdl &&
ghdl -e $PA3 Wrapper &&
iterate ./wrapper &&

echo $'\e[32m'"Benchmark : OK"$'\e[0m'
